/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2015 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/G13 V2.03.02.01 [15 May 2015]
* Device(s)    : R5F100LE
* Tool-Chain   : CCRL
* Description  : This file implements main function.
* Creation Date: 2016/01/13
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_serial.h"
#include "r_cg_timer.h"
#include "r_cg_it.h"
/* Start user code for include. Do not edit comment generated here */
#include "r_iic_lib.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
#pragma interrupt r_it_interrupt(vect=INTIT,bank=RB2)
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
#define     MAX_DATA    ( 64 )                  /* max data number for one time */
#define     SLAVE_ADDR  ( 0x60 )                /* IIC bus slave address        */
#define     RAM_TOP     ( 0x80 )                /* RAM addr in slave register   */
#define     LED_ON      ( 0 )                   /* LED on data                  */
#define     RETRY       ( 10 )                  /* error retry upto 10 times    */


volatile uint8_t    g_read_ram[8][16];          /* receive RAM data buffer      */
volatile uint8_t    g_read_data[16][8];         /* receive data buffer          */
volatile uint8_t    g_write_data[MAX_DATA+1];   /* transmit data buffer         */


volatile uint8_t   g_025s_status;                /* 0.25s interrupt flag         */
volatile uint8_t   g_025s_count;                 /* 0.25s counter                */

uint8_t g_IIC_put_data( uint8_t s_addr, uint8_t r_addr, uint8_t __far * const buffer, uint8_t tx_num );
uint8_t g_IIC_get_data( uint8_t s_addr, uint8_t r_addr, uint8_t * const buffer, uint8_t rx_num );

void wait_50ms(void);
void wait_250ms(void);
void g_wait_SW(void);

static uint8_t const __far  dispdata[22][2] =
{ 
    {0b00000000, 0b00000000},
    {0b10000001, 0b00000001},
    {0b11000011, 0b00000011},
    {0b11100111, 0b00000111},
    {0b11111111, 0b00001110},
    {0b01111110, 0b00011100},
    {0b00111100, 0b00111000},
    {0b00011000, 0b01110000},
    {0b00000000, 0b11100000},
    {0b00011000, 0b11000000},
    {0b00111100, 0b10000000},
    {0b01111110, 0b00000000},
    {0b11111111, 0b10000000},
    {0b11100111, 0b11000000},
    {0b11000011, 0b11100000},
    {0b10000001, 0b01110000},
    {0b00000000, 0b00111000},
    {0b00011000, 0b00011100},
    {0b00100100, 0b00001110},
    {0b01000010, 0b00000111},
    {0b10000001, 0b00000011},
    {0b00000000, 0b00000001}
};

static uint8_t const __far  ram_data[8][64] =
{ 
    /* increment data patern1 :0x80-0xBF */
    {0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,
     0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
     0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,
     0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
     0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,
     0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
     0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
     0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF},

    /* increment data patern2 :0xC0-0xFF */
    {0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
     0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
     0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
     0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
     0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
     0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
     0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
     0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF},

    /* decrement data patern1 :0xFF-0xC0 */
    {0xFF,0xFE,0xFD,0xFC,0xFB,0xFA,0xF9,0xF8,
     0xF7,0xF6,0xF5,0xF4,0xF3,0xF2,0xF1,0xF0,
     0xEF,0xEE,0xED,0xEC,0xEB,0xEA,0xE9,0xE8,
     0xE7,0xE6,0xE5,0xE4,0xE3,0xE2,0xE1,0xE0,
     0xDF,0xDE,0xDD,0xDC,0xDB,0xDA,0xD9,0xD8,
     0xD7,0xD6,0xD5,0xD4,0xD3,0xD2,0xD1,0xD0,
     0xCF,0xCE,0xCD,0xCC,0xCB,0xCA,0xC9,0xC8,
     0xC7,0xC6,0xC5,0xC4,0xC3,0xC2,0xC1,0xC0},

    /* decrement data patern2 :0xBF-0x80 */
    {0xBF,0xBE,0xBD,0xBC,0xBB,0xBA,0xB9,0xB8,
     0xB7,0xB6,0xB5,0xB4,0xB3,0xB2,0xB1,0xB0,
     0xAF,0xAE,0xAD,0xAC,0xAB,0xAA,0xA9,0xA8,
     0xA7,0xA6,0xA5,0xA4,0xA3,0xA2,0xA1,0xA0,
     0x9F,0x9E,0x9D,0x9C,0x9B,0x9A,0x99,0x98,
     0x97,0x96,0x95,0x94,0x93,0x92,0x91,0x90,
     0x8F,0x8E,0x8D,0x8C,0x8B,0x8A,0x89,0x88,
     0x87,0x86,0x85,0x84,0x83,0x82,0x81,0x80},

    /* decrement data patern3 :0x7F-0x40 */
    {0x7F,0x7E,0x7D,0x7C,0x7B,0x7A,0x79,0x78,
     0x77,0x76,0x75,0x74,0x73,0x72,0x71,0x70,
     0x6F,0x6E,0x6D,0x6C,0x6B,0x6A,0x69,0x68,
     0x67,0x66,0x65,0x64,0x63,0x62,0x61,0x60,
     0x5F,0x5E,0x5D,0x5C,0x5B,0x5A,0x59,0x58,
     0x57,0x56,0x55,0x54,0x53,0x52,0x51,0x50,
     0x4F,0x4E,0x4D,0x4C,0x4B,0x4A,0x49,0x48,
     0x47,0x46,0x45,0x44,0x43,0x42,0x41,0x40},

    /* decrement data patern4 :0x3F-0x00 */
    {0x3F,0x3E,0x3D,0x3C,0x3B,0x3A,0x39,0x38,
     0x37,0x36,0x35,0x34,0x33,0x32,0x31,0x30,
     0x2F,0x2E,0x2D,0x2C,0x2B,0x2A,0x29,0x28,
     0x27,0x26,0x25,0x24,0x23,0x22,0x21,0x20,
     0x1F,0x1E,0x1D,0x1C,0x1B,0x1A,0x19,0x18,
     0x17,0x16,0x15,0x14,0x13,0x12,0x11,0x10,
     0x0F,0x0E,0x0D,0x0C,0x0B,0x0A,0x09,0x08,
     0x07,0x06,0x05,0x04,0x03,0x02,0x01,0x00},

    /* increment data patern3 :0x00-0x3F */
    {0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
     0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
     0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
     0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
     0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
     0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
     0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
     0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F},

    /* increment data patern4 :0x40-0x7F */
    {0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
     0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
     0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
     0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
     0x60,0x61,0x62,0x63,0x64,0x65,0x66,0xE7,
     0x68,0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,
     0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,
     0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F}

};
/* End user code. Do not edit comment generated here */
void R_MAIN_UserInit(void);

/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */

  {

    uint8_t status;
    uint8_t main_loopc;                 /* loop counter for main loop   */
    uint8_t i;                          /* loop counter for subloop     */
    uint8_t j;                          /* loop counter for subloop     */
    uint8_t k;                          /* loop counter for subloop     */
    uint8_t __far const *pt_txdata;     /* write data to slave pointer  */
    uint8_t *pt_ram;                    /* read RAM data pointer        */
    uint8_t reg_addr;                   /* register address in slave    */
    uint8_t temp_data;                  /* work area for read data      */
    uint8_t ram_valid;                  /* RAM data is valid flag       */


    ram_valid = FALSE;                  /* start with RAM is not valid  */
    main_loopc = 0x06;                  /* write data buffer number     */


    g_wait_SW();                        /* wait for SW is pushed        */

    while (1U)
    {
/*
    Test1 : move LED display pattern
*/

        reg_addr = 0x00;
        for ( i = 0 ; i < 22 ; i++ )
        {
            pt_txdata = (&dispdata[i][0]);
            status = g_IIC_put_data( SLAVE_ADDR, reg_addr, (uint8_t __far *)pt_txdata, 2 );

            if ( status )
            {
                P6_bit.no3 = LED_ON;    /* turn on LED when NACK        */
            }
            else
            {
                /* do nothing */
            }

            wait_50ms();
        }
/*
    Test2 : RAM area data read by 16 bytes unit
*/
        for ( j = 0x00 ; j < 0x08 ; j++ )
        {
            pt_ram = (uint8_t *)&g_read_ram[j][0];
            reg_addr = (RAM_TOP + j*0x10);
            status = g_IIC_get_data( SLAVE_ADDR, reg_addr, pt_ram, 0x10 );

            if ( status )
            {
                P6_bit.no3 = LED_ON;    /* turn on LED when NACK        */
            }
            else
            {
                /* do nothing */
            }
        }

/*
    Test3 : check read data of RAM
*/

    if( TRUTH == ram_valid )
    {
        for ( i = 0 ; i < 8 ; i++ )     /* check read 1st 64 bytes data */
        {
            for ( j = 0 ; j < 16 ; j++ )
            {
                k = i >> 2;
                temp_data = ((( i & 0b00000011 ) * 16 ) + j); /* get offset for 64 */
                temp_data = ram_data[main_loopc+k][temp_data]; /* get data      */

                if ( temp_data != g_read_ram[i][j] )
                {                       /* detect data error            */
                    P6_bit.no3 = LED_ON;/* turn on LED when NACK        */
                }
                else
                {
                    /* do nothing */
                }
            }
        }
        
    }

/*
    Test4 : RAM area data write by 64 bytes(MAX_DATA) unit
*/

        if ( 0x06 > main_loopc )        /* write data buffer check      */
        {
            main_loopc += 2;
        }
        else
        {
            main_loopc = 0;
        }

        for ( k = 0x00 ; k < 0x02 ; k++ )
        {
            pt_txdata = &ram_data[main_loopc+k][0]; /* set write data pointer   */
            reg_addr = (RAM_TOP + k*0x40);      /* set access RAM address   */
            status = g_IIC_put_data( SLAVE_ADDR, reg_addr, (uint8_t __far *)pt_txdata, MAX_DATA );

            if ( status )
            {
                P6_bit.no3 = LED_ON;    /* turn on LED when NACK        */
            }
            else
            {
                /* do nothing */
            }
            
        }

        ram_valid = TRUTH;              /* set RAM data is valid        */

/*
    Test5 : A/D convert data read until SW is pushed

    A/D convert data is stored in g_read_data,
    then check 4 data( 8 bytes).

*/
        while ( TRUTH == P13_bit.no7 )
        {
            for ( i = 0 ; i < 16 ; i++ )
            {
                reg_addr = 0;           /* read from TOP of A/D data    */
                pt_ram = (uint8_t *)&g_read_data[i][0];
                status = g_IIC_get_data( SLAVE_ADDR, reg_addr, pt_ram, 0x08 );

                if ( status )           /* detect ACK/NACK              */
                {
                    P6_bit.no3 = LED_ON;/* turn on error LED(LED2)      */
                }
                else
                {
                    /* do nothing */
                }
            }

        }

        P6_bit.no2 ^= 1;                /* turn on/off LED1 of TB       */

    }
  }
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */

/* use TM03 for delay count mode */

    IIC_TM03_init();                    /* start TM03               */

/* start IT                       */

    g_025s_status = 0;
    g_025s_count = 0;
    ITMC |= 0x8000;                     /* start IT		    */
    ITIF = FALSE;                       /* clear interrupt flag	    */
    ITMK = INT_ENABLE;                  /* enable IT interrupt	    */

    EI();

    wait_250ms();                       /* wait for 0.5s	    */

    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/*******************************************************************************
* Function Name: g_wait_SW
* Description  : This function wait for SW is pushed
* Arguments    : None
* Return Value : None
********************************************************************************/
void g_wait_SW(void)
{
    while ( FALSE == P13_bit.no7 )
    {
        NOP();
    }
    wait_50ms();
    while ( TRUTH == P13_bit.no7 )
    {
        NOP();
    }
    wait_50ms();
}

/***********************************************************************************************************************

    IIC bus device control routines based on r_IIC_LIB.c

***********************************************************************************************************************/

/*******************************************************************************
* Function Name: g_IIC_put_data
* Description  : This function transmit data to specified slave
* Arguments    : slave address, register address, data buffer address, data numer
* Return Value : 00:successs
*                not 00:error
********************************************************************************/
uint8_t g_IIC_put_data( uint8_t s_addr, uint8_t r_addr, uint8_t __far * const buffer, uint8_t tx_num )
{
    uint8_t cnt;
    uint8_t cnt2;
    uint8_t __far * ptr;
    uint8_t status;
    uint8_t retry_count;

    cnt = tx_num;                       /* set transmit data number     */
    g_write_data[0] = r_addr;           /* set register address         */
    ptr = buffer;

    for ( cnt2 = 0 ; cnt2 < cnt ; cnt2++ )
    {

/*--------------------------------------
    copy transmit data to transmit buffer
--------------------------------------*/

        g_write_data[cnt2+1] = *ptr;
        ptr++;
    }

/*--------------------------------------
    start transmission 
--------------------------------------*/
    for ( retry_count = RETRY ; retry_count > 0 ; )
    {

        status = R_IIC_Master_Send(s_addr, (uint8_t *__near)g_write_data, cnt+1);

        if( IIC_SUCCESS == status )     /* check start successfully     */
        {

/*--------------------------------------
    transmit start and 
    wait for transmission end
--------------------------------------*/

            do
            {                           /* wait for transmission end    */

                status = R_IIC_check_comstate(); /* get IIC status          */

            }while( IIC_USING == ( status & IIC_STS_MASK ) );
        
        }
        else
        {
            /* do nothing */
        }
/*--------------------------------------
    transmission end
--------------------------------------*/
        if( NO_SLAVE == status )
        {                               /* no ACK for slave address     */
            R_IIC_StopCondition();      /* issue stop condition         */
            wait_5us();                 /* wait for retry timing        */
            retry_count--;
        }
        else
        {
            retry_count = 0;
        }

    }
/*
    release IIC  bus
*/
    if( NO_SLAVE != status )
    {
        R_IIC_StopCondition();          /* issue stop condition         */
    }
    else
    {
            /* do nothing */
    }


    return (status);

}

/*******************************************************************************
* Function Name: g_IIC_get_data
* Description  : This function transmit data to specified slave
* Arguments    : slave address, register address, data buffer address, data numer
* Return Value : 00:successs
*                not 00:error
********************************************************************************/
uint8_t g_IIC_get_data( uint8_t s_addr, uint8_t r_addr, uint8_t * const buffer, uint8_t rx_num )
{

    uint8_t status;
    uint8_t retry_count;

    g_write_data[0] = r_addr;           /* set register address         */

    for ( retry_count = RETRY ; retry_count > 0 ; )
    {
/*--------------------------------------
    transmit register address
--------------------------------------*/

        status = R_IIC_Master_Send(s_addr, (uint8_t *__near)g_write_data, 1);

        if( IIC_SUCCESS == status )     /* check start successfully     */
        {

/*--------------------------------------
    wait for transmission end
--------------------------------------*/

            do
            {

                status = R_IIC_check_comstate(); /* get IIC status  */

            }while( IIC_USING == ( status & IIC_STS_MASK ) );

        }
        else
        {
                /* do nothing */
        }

/*--------------------------------------
   transmission end and check result
--------------------------------------*/

        if( NO_SLAVE == status )
        {                               /* no ACK for slave address     */
            R_IIC_StopCondition();      /* issue stop condition         */
            wait_5us();                 /* wait for retry timing        */
            retry_count--;
        }
        else
        {
            retry_count = 0;
        }
    }

/*--------------------------------------
   transmission end
--------------------------------------*/

    if ( IIC_SUCCESS == status )        /* check result         */
    {

/*--------------------------------------
   start IIC receiving
--------------------------------------*/

        status = R_IIC_Master_Receive(s_addr, (uint8_t *__near)buffer, rx_num);

        if( status == 0)                /* check start successfully     */
        {

/*--------------------------------------
    wait for receive end
--------------------------------------*/

            do
            {
                status = R_IIC_check_comstate();

            }while( IIC_USING == ( status & IIC_STS_MASK ) );
        }
        else
        {
            /* do nothing */
        }

    }
    else
    {
        /* do nothing */
    }

    if( NO_SLAVE != status )
    {
        R_IIC_StopCondition();          /* issue stop condition     */
    }
    else
    {
            /* do nothing */
    }

    return (status);

}
/***********************************************************************************************************************

    Long range timer functions

***********************************************************************************************************************/

/*******************************************************************************
* Function Name: wait_50ms
* Description  : This function wait for 50ms
* Arguments    : none
* Return Value : none
********************************************************************************/
void wait_50ms(void)
{
    g_025s_count = ( 5-1 );                     /* set remain time to 50ms */

/*--------------------------------------
   wait for remaining time
--------------------------------------*/

    while ( FALSE == g_025s_status )            /* wait for IT interrupt    */
    {
        HALT();
        NOP();
    }

    g_025s_status = FALSE;

}

/*******************************************************************************
* Function Name: wait_250ms
* Description  : This function wait for 250ms
* Arguments    : none
* Return Value : none
********************************************************************************/
void wait_250ms(void)
{
    g_025s_status = 0;
    while ( FALSE == g_025s_status )            /* wait for IT interrupt    */
    {
        HALT();
        NOP();
    }

    g_025s_status = FALSE;

}

/********************************************************************************
* Function Name: r_it_interrupt
* Description  : This function is 0.05sec interrupt service routine.
* Arguments    : None
* Return Value : None
*********************************************************************************/
static void r_it_interrupt(void)
{

    g_025s_count++;
    if( 5 == g_025s_count )
    {
        g_025s_status = TRUTH;          /* set 0.25s flag           */
        g_025s_count = 0;
    }


}

/* End user code. Do not edit comment generated here */
